﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MasterDetailWithPanel
{
	/// <summary>
	/// Třída pro lazy loading
	/// </summary>
	public class LazyLoader
	{

		#region Properties
		#endregion

		#region Methods

		///<summary>
		/// Metoda pro lazy loading
		///</summary>
		///<param name="obj">Objekt, který se má načíst, pokud je prázdný</param>
		///<param name="loadingFunction">Akce pro načení objektu</param>
		///<typeparam name="TObject">Type objektu, který se má načíst, pokud je prázdný</typeparam>
		///<returns>Objekt, který se má načíst, pokud je prázdný</returns>
		public TObject LazyLoad<TObject>(ref TObject obj, Func<TObject> loadingFunction)
			where TObject : class
		{
			if (obj == null)
			{
				lock (_lockObject)
				{
					if (obj == null)
					{
						obj = loadingFunction();
					}
				}
			}
			return obj;
		}

		#endregion

		#region Constructors

		#endregion

		#region Events

		#endregion

		#region Other Members

		private readonly object _lockObject = new object();

		#endregion

	}
}
