﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Byznys.Entities.Fakturace;
using Stimulsoft.Report;

namespace MasterDetailWithPanel
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private StandardniVydanaFaktura CreateFaktura()
		{
			return new StandardniVydanaFaktura()
			{
				RadaACisloVstupu = "TEST1",
				RadekSet = new List<Radek>()
				{
					new Radek()
					{
						Cislo = "R1",
						CelkovaCenaRadku = 11,
						SeznamSeriovychCiselALokaciSet = new List<LokaceASerioveCislo>()
						{
							new LokaceASerioveCislo()
							{
								VyrobniCislo = "V11"
							},
							new LokaceASerioveCislo()
							{
								VyrobniCislo = "V12"
							}
						}
					},
					new Radek()
					{
						Cislo = "R1",
						CelkovaCenaRadku = 11,
						SeznamSeriovychCiselALokaciSet = new List<LokaceASerioveCislo>()
						{
							new LokaceASerioveCislo()
							{
								VyrobniCislo = "V21"
							}
						}
					}
				}
			};
		}

		private void Button_Click_CallStackOverflow(object sender, RoutedEventArgs e)
		{
			var report = new StiReport();

			var fileName = "report_callstackoverflow.mrt";
				// "report_printerrors.mrt";

			if (!File.Exists(fileName))
			{
				MessageBox.Show("File Not Found: " + fileName);
				return;
			}
			report.Load(fileName);

			var faktura = CreateFaktura();

			report.RegBusinessObject(faktura.GetType().Name, faktura);
			report.DesignWithWpf(); // .ShowWithWpf();
		}

		private void Button_Click_PreviewCallStackOverflow(object sender, RoutedEventArgs e)
		{
			var report = new StiReport();

			var fileName = "report_callstackoverflow.mrt";
			// "report_printerrors.mrt";

			if (!File.Exists(fileName))
			{
				MessageBox.Show("File Not Found: " + fileName);
				return;
			}
			report.Load(fileName);

			var faktura = CreateFaktura();

			report.RegBusinessObject(faktura.GetType().Name, faktura);
			report.ShowWithWpf();
		}

		private void Button_Click_PrintErrors(object sender, RoutedEventArgs e)
		{
			var report = new StiReport();

			var fileName = "report_printerrors.mrt";
			// "report_printerrors.mrt";

			if (!File.Exists(fileName))
			{
				MessageBox.Show("File Not Found: " + fileName);
				return;
			}
			report.Load(fileName);

			var faktura = CreateFaktura();

			report.RegBusinessObject(faktura.GetType().Name, faktura);
			report.DesignWithWpf(); // .ShowWithWpf();
		}
	}
}
